#include <stdint.h>
//#include <iLCD_SPI_Bib.c>

#define orange 	255,165,  0
#define rot 	255,  0,  0
#define schwarz   0,  0,  0
#define blau 	  0,  0,255



//****************************************************************************
void iLCD_init()
{
  ResetAll();
  SetBackgroundColor(schwarz);		// schwarz
  SetForegroundColor(orange);	// orange
  EraseDisplay();


  // EGT Hintergrund
  SelectViewport(0);				// Hauptbildschirm auswhlen
  SetCursorPosition(9,9);			// Erste Koordinate fr EGT Feld
  DefineViewport(1,0,302,74);		// EGT Feld, 0-Orientierung, 302x62 Pixel
  SelectViewport(1);				// Viepoprt auswhlen
  SetBackgroundColor(schwarz);		// schwarz
  SetForegroundColor(orange);	// orange
  SetBorderColor(orange);		// Rahmen Farbe
  // Beschriftung
  SetCursorPosition(0,4);
  SetFont(1);						// mittlere Schriftgre
  WriteText("EGT");
  SetFont(0);						// mittlere Schriftgre
  SetCursorPosition(82,12);
  WriteText("Max");
  SetCursorPosition(200,12);
  WriteText("Diff");
  SetCursorPosition(287,12);
  WriteText("C");
   // Bargraf Beschriftung
  SetCursorPosition(232,62);
  DrawLine(232, 68);				// 850C Markierung
  SetFont(3);						// ganz kleine Schrift
  SetCursorPosition(0, 61);
  WriteText("0");
  SetCursorPosition(212, 61);
  WriteText("850");
  SetCursorPosition(283, 61);
  WriteText("1100");
  // Rahmen
  SetCursorPosition(0,34);
  DrawRectangle(0, 302, 28);		// zum Schluss Zeichnen, damit die Beschriftung den Rahmen nicht unterbricht (berschreibt)


  // BPC Hintergrund
  SelectViewport(0);				// Hauptbildschirm auswhlen
  SetCursorPosition(9,105);			// Zweite Koordinate fr BPC Feld
  DefineViewport(2,0,302,53);		// BPC Feld 0-Orientierung 302x62 Pixel
  SelectViewport(2);				// Viepoprt auswhlen
  SetBackgroundColor(schwarz);		// schwarz
  SetForegroundColor(orange);	// orange
  SetBorderColor(orange);		// Rahmen Farbe
  // Beschriftung
  SetCursorPosition(0,4);
  SetFont(1);						// mittlere Schriftgre
  WriteText("BPC2");
  SetFont(0);						// mittlere Schriftgre
  SetCursorPosition(280,12);
  WriteText("Bar");
  // Bargraf Beschriftung
  SetCursorPosition(99,41);
  DrawLine(99, 47);
  SetFont(3);						// ganz kleine Schrift
  SetCursorPosition(0, 40);
  WriteText("-1");
  SetCursorPosition(91, 40);
  WriteText("0");
  SetCursorPosition(297, 40);
  WriteText("2");
  // Rahmen
  SetCursorPosition(0,34);
  DrawRectangle(0, 302, 7);		// Rahmen fr Bargrafen


  // LPG Hintergrund
  SelectViewport(0);				// Hauptbildschirm auswhlen
  SetCursorPosition(9,180);			// dritte Koordinate fr LPG Feld
  DefineViewport(3,0,302,53);		// LPG Feld 0-Orientierung 302x62 Pixel
  SelectViewport(3);				// Viepoprt auswhlen
  SetBackgroundColor(schwarz);		// schwarz
  SetForegroundColor(orange);	// orange
  SetBorderColor(orange);		// Rahmen Farbe
  // Beschriftung
  SetCursorPosition(0,4);
  SetFont(1);						// mittlere Schriftgre
  WriteText("LPG");
  SetFont(0);						// mittlere Schriftgre
  SetCursorPosition(151,12);
  WriteText("Liter");
  // Bargraf Beschriftung
  SetCursorPosition(29,41);
  DrawLine(29, 47);
  SetFont(3);						// ganz kleine Schrift
  SetCursorPosition(0, 40);
  WriteText("0");
  SetCursorPosition(22, 40);
  WriteText("5");
  SetCursorPosition(291, 40);
  WriteText("50");
  // Rahmen
  SetCursorPosition(0,34);
  DrawRectangle(0, 302, 7);		// Rahmen fr Bargrafen
  

}//init







//*****************************************************************
// Erwartet ein 5 Zeiliges int Feld mit den Temperaturwerten in 1-4. Zeile 0 wird nicht ausgewertet
void iLCDUpdateEGT(int *EGT)
{
  static int EGT_last_data[5];

  // Funktion nur ausfhren wenn sich die EGT Werte gendert haben
  char i=0;
  for (char j=1; j<5; j++)
    {
	 if (!(EGT[j] == EGT_last_data[j])) i=1;
	}
  if (i==0) return;  // keine neuen Werte vorhanden
  
  
  // neuen Stand abspeichern
  for (i=1; i<5; i++)
    {
     EGT_last_data[i] = EGT[i];
	}


  // Los gehts
  int Min = EGT[1];
  int Max = EGT[1];
  int Diff;
  int32_t tmp=0;
  char string[7];


  // nach Min und Max suchen
  for (i=1; i < 5; i++) {
    if (Min > EGT[i]) Min = EGT[i];
    if (Max < EGT[i]) Max = EGT[i];
  }


  // Differenz berechnen
  Diff = Max - Min;
  

  // Messwerte fr Bargrafen skalieren
  for (i=1; i < 5; i++) {
    tmp = EGT[i];
    tmp = tmp * 302;
	tmp = tmp / 1100;
	EGT[i] = tmp;
  }


  // Werte aufs Display bringen
  SelectViewport(1);	// EGT Feld
  SetBackgroundColor(schwarz);		// schwarz
  SetForegroundColor(orange);	// orange
  SetBorderColor(orange);		// Rahmen Farbe


  // Feld fr Bargrafen lschen
  SetCursorPosition(1,35);
  EraseDisplayArea(300, 26);


  // Bargraf fr EGT 1 zeichnen
  SetCursorPosition(0,35);
  DrawRectangle(0b00011000, EGT[1], 5);	//Bargraf Zeichenen gefllt mit vordergrundfarbe
  // Bargraf fr EGT 2 zeichnen
  SetCursorPosition(0,42);
  DrawRectangle(0b00011000, EGT[2], 5);	//Bargraf Zeichenen gefllt mit vordergrundfarbe
  // Bargraf fr EGT 3 zeichnen
  SetCursorPosition(0,49);
  DrawRectangle(0b00011000, EGT[3], 5);	//Bargraf Zeichenen gefllt mit vordergrundfarbe
  // Bargraf fr EGT 4 zeichnen
  SetCursorPosition(0,56);
  DrawRectangle(0b00011000, EGT[4], 5);	//Bargraf Zeichenen gefllt mit vordergrundfarbe



  // Max und Diff schreiben
  SetFont(2);									// ganz groe Schrift
  SetForegroundColor(schwarz);					// Schwarze Schrift
  
  // Feld fr "Max" lschen
  SetCursorPosition(112,0);
  EraseDisplayArea(72, 31);
  // Max schreiben
  if (Max >= 850) SetBackgroundColor(rot);		// rot 
  if (Max < 850) SetBackgroundColor(orange);	// orange
  if (Max < 400) SetBackgroundColor(blau);	   	// blau
  SetCursorPosition(112,0);
  SetTextAlignment(0b10011000, 70, 31);    	// Text links unten ausgerichtet
  string[0] = 91;							// "Lerzeichen" am Anfang
  itoa(Max, &string[1], 10);				// Wert in akii Zeichen wandeln ab dem zweiten Zeichen
  WriteText(string);


  // Feld fr "Diff" lschen
  SetBackgroundColor(schwarz);					// schwarz 
  SetCursorPosition(222,0);
  EraseDisplayArea(65, 31);
  // Diff schreiben
  if (Diff >= 80) SetBackgroundColor(rot);		// rot 
  if (Diff < 80) SetBackgroundColor(orange);	// orange
  SetCursorPosition(222,0);						// SetCursorPosition
  string[0] = 91;								// "Lerzeichen" am Anfang
  itoa(Diff, &string[1], 10);					// Wert in akii Zeichen wandeln
  SetTextAlignment(0b10011100, 58, 31);	    // Text rechtsbndig und am Boden haftend
  WriteText(string);



}//iLCDUpdateEGT




//***********************************************************************************
// Erwartet den Ladedruck als 4-Stellige milli Bar in Askii Zeichen mit fhrender Polaritt z. B. +0775 = 0,775 Bar
// Erwartet die Kennlinienbezeichnung als 8 - Akii Zeichen
void iLCDUpdateBPC(char *cBoost, char *cCharacteristic) 
  {


  static char cBoost_last_data[5], cCharacteristic_last_data[8]; 
  char string[7];

  // Funktion nur ausfhren wenn sich die Werte gendert haben
  char i=0;
  // Boost
  for (char j=0; j<5; j++)
    {
	 if (!(cBoost[j] == cBoost_last_data[j])) i=1;
	}

 // Kennlinie
 for (char j=0; j<8; j++)
    {
	 if (!(cCharacteristic[j] == cCharacteristic_last_data[j])) i=1;
	}

  if (i==0) return;  // keine neuen Werte vorhanden
  
  
  // neuen Stand abspeichern
  for (i=0; i<5; i++)
    {
     cBoost_last_data[i] = cBoost[i];
	}

  for (i=0; i<8; i++)
    {
     cCharacteristic_last_data[i] = cCharacteristic[i];
	}




  // Los gehts, die Werte sollen aktualisiert werden

  int Boost = atoi(cBoost), BarLenght;
  int32_t tmp=0;


  // Messwerte fr Bargrafen skalieren
  tmp = Boost;
  tmp = tmp + 1000;		// Nullpunkt nach -1 verschieben
  tmp = tmp * 302;
  tmp = tmp / 3000;
  BarLenght = tmp;
 

  // Werte aufs Display bringen
  SelectViewport(2);	// BPC Feld
  SetBackgroundColor(schwarz);		// schwarz
  SetForegroundColor(orange);	// orange
  SetBorderColor(orange);		// Rahmen Farbe


  // Feld fr Bargrafen lschen
  SetCursorPosition(1,35);
  EraseDisplayArea(300,5 );


  // Bargraf fr Boost zeichnen
  SetCursorPosition(0,35);
  DrawRectangle(0b00011000, BarLenght, 5);	//Bargraf Zeichenen gefllt mit Vordergrundfarbe

 
  // Feld fr Kennlinienbezeichnung lschen
  SetCursorPosition(82,12);
  EraseDisplayArea(176, 20);
  // Kennlinienbezeichnung schreiben
  SetFont(0);						// mittlere Schriftgre
  SetCursorPosition(82,12);
  WriteText(cCharacteristic);


 // Feld fr "Boost" lschen
  SetBackgroundColor(schwarz);					
  SetCursorPosition(160,0);
  EraseDisplayArea(112,31 );

  // Boost Wert schreiben
  SetFont(2);						// ganz groe Schrift
  SetForegroundColor(schwarz);					
  if (Boost >= 1500) SetBackgroundColor(rot);	// rot 
  if (Boost < 1500) SetBackgroundColor(orange);	// orange
  SetCursorPosition(160,0);						// SetCursorPosition
  SetTextAlignment(0b10011100, 112, 31);	    // Text rechtsbndig und am Boden haftend
  
  string[0] = 91;				// "Leerzeichen"
  string[1] = *cBoost++;		// Vorzeichen
  string[2] = *cBoost++;
  string[3] = ',';				// Komma einfgen
  string[4] = *cBoost++;
  string[5] = *cBoost;
  string[6] = 0;				// String Abschluss
 
  WriteText(string);	
 


}// iLCDUpdateBPC





//**************************************************************************************
// Erwartet den Fllzustand des LPG Tanks in Liter x 100
// Erwartet den LPG Status als 0 = Aus, 1 = Ein, 2 = in Vorbereitung
void iLCDUpdateLPG(int Tank, char Status)
  {
 
    static unsigned int Tank_last_data;
    static char Status_last_data;
    char i=0;
	
	// Checken ob neue Daten eingetroffen sind
    if (! (Tank == Tank_last_data)) i = 1;
    if (! (Status == Status_last_data)) i = 1;
    if (i == 0) return;   	// Werte haben sich nicht verndert
    // neuen Stand abspeichern
	Tank_last_data = Tank;
	Status_last_data = Status;


	// Werte aufs Display bringen
    int BarLength;
	int32_t tmp=0;
	char string[3];

	// Messwerte fr Bargrafen skalieren
    tmp = Tank;
    tmp = tmp * 302;
	tmp = tmp / 50;
    tmp = tmp / 100;
	BarLength = tmp;

   
    SelectViewport(3);	// LPG Feld
    SetBackgroundColor(schwarz);		// schwarz
    SetForegroundColor(orange);	// orange
    SetBorderColor(orange);		// Rahmen Farbe


    // Feld fr Bargrafen lschen
    SetCursorPosition(1,35);
    EraseDisplayArea(300, 5);

    // Bargraf fr EGT 1 zeichnen
    SetCursorPosition(0,35);
    DrawRectangle(0b00011000, BarLength, 5);	//Bargraf Zeichenen gefllt mit vordergrundfarbe



    // Liter schreiben
    SetFont(2);									// ganz groe Schrift
    SetForegroundColor(schwarz);					// Schwarze Schrift
  
    // Feld fr "Liter" lschen
    SetCursorPosition(98,0);
    EraseDisplayArea(50, 31);
    // Liter schreiben
    if (Tank > 500) SetBackgroundColor(orange);	// orange 
    if (Tank <= 500) SetBackgroundColor(rot);	// rot
    SetCursorPosition(98,0);
	tmp = Tank / 100;
	if((Tank - (tmp * 100)) >= 50) tmp = tmp+1;   // aufrunden ab 0,5l
	Tank = tmp;
//	DrawRectangle(0,50,31);
	string[0] = 91;								// "Lerzeichen" am Anfang
    itoa(Tank, &string[1], 10);					// Wert in akii Zeichen wandeln
    SetTextAlignment(0b10011100, 45, 31);	    // Text rechtsbndig und am Boden haftend
    WriteText(string);




	// Status schreiben
	SetFont(2);									// ganz groe Schrift
    SetForegroundColor(schwarz);				// Schwarze Schrift
	// Feld fr "Status" lschen
    SetCursorPosition(200,0);
	SetBackgroundColor(schwarz);					 
    EraseDisplayArea(102, 31);
    // Liter schreiben
    SetCursorPosition(200,0);
	SetTextAlignment(0b10011100, 98, 31);	    // Text rechtsbndig und am Boden haftend
    switch (Status)
	  {
	    case 0: SetBackgroundColor(rot);	// rot
		        WriteText("[OFF");			// inclusive Anfangs-Leerzeichen "["
				break;

		case 1: SetBackgroundColor(orange);	// orange
		        WriteText("[ON");
				break;

	    case 2: SetBackgroundColor(rot);	// orange
		        WriteText("[PREP");
				break;

	  }
  

  }//iLCDUpdateLPG






